import 'package:flutter/widgets.dart';
import 'package:power_widget/serializable/WidgetSerializableModel.dart';
import 'package:power_widget/widgets/PowerCardView.dart';
import 'package:power_widget/widgets/stateful/ModularizedStatefulWidget.dart';

abstract class PowerStatefulCardView extends ModularizedStatefulWidget with PowerCardView {
  PowerStatefulCardViewState state;

  @override
  State<StatefulWidget> createState() {
    // TODO: implement createState
    state = PowerStatefulCardViewState(getSize(), provideCardViewPainter(), provideChildrenStack());
    return state;
  }

  @override
  WidgetSerializableModel getWidgetSerializableModel() {
    // TODO: implement getWidgetSerializableModel
    return null;
  }

  void notifyWidgetUpdate() {
    this.state.setChildrenStack(provideChildrenStack());
    state.notifyWidgetUpdate();
  }
}

class PowerStatefulCardViewState extends State<PowerStatefulCardView> {
  CustomPainter customPainter;
  Stack childrenStack;
  Size size;
  PowerCardView powerCardView;

  PowerStatefulCardViewState(this.size, this.customPainter, this.childrenStack);

  void setChildrenStack(Stack stack) {
    this.childrenStack = stack;
  }

  void notifyWidgetUpdate() {
    setState(() {});
  }

  @override
  Widget build(BuildContext context) {
    // TODO: implement build
    return Center(
      child: CustomPaint(
        child: this.childrenStack,
        size: size,
        painter: this.customPainter,
      ),
    );
  }
}
